#include <stdio.h>
#include <String.h>
#include "SampleComponents.h"


// TBCL_TOAEdit

TBCL_TOAEdit::TBCL_TOAEdit(instantiation_info_t *info)
	:	TBCL_BTextControl(info)
{
}

TBCL_TOAEdit::~TBCL_TOAEdit()
{
}

BArchivable *TBCL_TOAEdit::Instantiate()
{
	TOAEdit *oaEdit = new TOAEdit(BRect(0,0,200,0), "", "", "", NULL);
	oaEdit->SetDivider(70);
	return oaEdit;
}

const char *TBCL_TOAEdit::SupportedClass() const
{
	return typeid(TOAEdit).name();
}

void TBCL_TOAEdit::PropertyList(TPropertyRegistrar *propertyRegistrar) const
{
	propertyRegistrar->AddProperty(this, "EnableEnter", B_BOOL_TYPE, NULL, &BOOLEAN_VALUES);
	propertyRegistrar->AddProperty(this, "EnableDownArrow", B_BOOL_TYPE, NULL, &BOOLEAN_VALUES);
	propertyRegistrar->AddProperty(this, "EnableUpArrow", B_BOOL_TYPE, NULL, &BOOLEAN_VALUES);
	TBCL_BTextControl::PropertyList(propertyRegistrar);
}

status_t TBCL_TOAEdit::SetValue(BArchivable *object, const char *propName, const char *value)
{
	_CAST(TOAEdit, object, oaEdit);
	status_t status = B_ERROR;
	
	bool enabled;
	if (strcmp(propName, "EnableEnter")==0) {
		status = get_bool(value, &enabled);
		if (status == B_OK) oaEdit->SetEnableEnter(enabled);
	} else if (strcmp(propName, "EnableDownArrow")==0) {
		status = get_bool(value, &enabled);
		if (status == B_OK) oaEdit->SetEnableDownArrow(enabled);
	} else if (strcmp(propName, "EnableUpArrow")==0) {
		status = get_bool(value, &enabled);
		if (status == B_OK) oaEdit->SetEnableUpArrow(enabled);
	} else {
		status = TBCL_BTextControl::SetValue(object, propName, value);
	}
	
	return status;
}

status_t TBCL_TOAEdit::GetValue(BArchivable *object, const char *propName, BString *value)
{
	_CAST(TOAEdit, object, oaEdit);
	
	if (strcmp(propName, "EnableEnter")==0) {
		value->SetTo(oaEdit->EnableEnter() ? "True" : "False");
	} else if (strcmp(propName, "EnableDownArrow")==0) {
		value->SetTo(oaEdit->EnableDownArrow() ? "True" : "False");
	} else if (strcmp(propName, "EnableUpArrow")==0) {
		value->SetTo(oaEdit->EnableUpArrow() ? "True" : "False");
	} else {
		TBCL_BTextControl::GetValue(object, propName, value);
	}
	
	return B_OK;
}
