/*==============================================================================
		GuiBerry・GenesTation 共有ヘッダファイル	Ver 1.11
==============================================================================*/

#ifndef	___GGShared_H_
#define	___GGShared_H_
//------------------------------------------------------------------------------
#include <be_errors.h>
#include <be_prim.h>
//==============================================================================
/* ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
ビュー：リソースに格納されている親ビュー
コンポーネント：ビューに張りついている子ビュー
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
//------------------------------------------------------------------------------
const int32		GG_ERR_BASE = 0x1000;
//------------------------------------------------------------------------------
// コマンド
const uint32	GG_COMPONENT_ADDED = 'GGad';					// GuiBerry → GenesTation コンポーネントが追加された（"refs", GG_MSG_NAME_RESOURCE_ID, GG_MSG_NAME_COMPONENT_NAME, GG_MSG_NAME_COMPONENT）
const uint32	GG_SAVE_ALL_REQUESTED_REPLY = 'GGar';			// GuiBerry → GenesTation 全てのリソースを保存のリプライ（GG_MSG_NAME_RESULT, "refs"）
const uint32	GG_SAVE_ALL_REQUESTED = 'GGas';					// GenesTation → GuiBerry 全てのリソースを保存（void）
const uint32	GG_COMPONENT_SELECTION_CHANGED = 'GGcc';		// GuiBerry → GenesTation 違うコンポーネントが選択された（"refs", GG_MSG_NAME_RESOURCE_ID, GG_MSG_NAME_COMPONENT_NAME, GG_MSG_NAME_COMPONENT）
const uint32	GG_SEND_VIEW_REQUESTED_REPLY = 'GGer';			// GuiBerry → GenesTation ビュー（全てのコンポーネントを含む）の送信要求のリプライ（GG_MSG_NAME_RESULT, GG_MSG_NAME_COMPONENT_NAME, GG_MSG_NAME_COMPONENT）
const uint32	GG_SEND_VIEW_REQUESTED = 'GGev';				// GenesTation → GuiBerry ビュー（全てのコンポーネントを含む）の送信要求（"refs", GG_MSG_NAME_RESOURCE_ID）
const uint32	GG_COMPONENT_INVOKED = 'GGiv';					// GuiBerry → GenesTation コンポーネントがダブルクリックされた（"refs", GG_MSG_NAME_RESOURCE_ID, GG_MSG_NAME_COMPONENT_NAME, GG_MSG_NAME_COMPONENT）
const uint32	GG_COMPONENT_NAME_CHANGED = 'GGnc';				// GuiBerry ←→ GenesTation コンポーネントの名前が変更された（GG_MSG_NAME_COMPONENT_NAME, GG_MSG_NAME_COMPONENT_NEW_NAME）
const uint32	GG_OPEN_VIEW_REQUESTED = 'GGop';				// GenesTation → GuiBerry ビューを開く（"refs", GG_MSG_NAME_RESOURCE_ID）
const uint32	GG_OPEN_VIEW_REQUESTED_REPLY = 'GGor';			// GuiBerry → GenesTation ビューを開くのリプライ（GG_MSG_NAME_RESULT）
const uint32	GG_COMPONENT_REMOVED = 'GGrm';					// GuiBerry → GenesTation コンポーネントが削除された（"refs", GG_MSG_NAME_RESOURCE_ID, GG_MSG_NAME_COMPONENT_NAME, GG_MSG_NAME_COMPONENT）
const uint32	GG_END_COMMUNICATION = 'GGqc';					// GenesTation → GuiBerry 通信終了（void）
const uint32	GG_START_COMMUNICATION = 'GGsc';				// GenesTation → GuiBerry 通信開始（GG_MSG_NAME_DESTINATION）
const uint32	GG_START_COMMUNICATION_REPLY = 'GGsr';			// GuiBerry → GenesTation 通信開始のリプライ（GG_MSG_NAME_RESULT, GG_MSG_NAME_DESTINATION, GG_MSG_NAME_VERSION）
// データ
const char		GG_MSG_NAME_COMPONENT[] = "Compo";				// BMessage
const char		GG_MSG_NAME_COMPONENT_NAME[] = "Name";			// String
const char		GG_MSG_NAME_COMPONENT_NEW_NAME[] = "NewName";	// String
const char		GG_MSG_NAME_DESTINATION[] = "Dest";				// BMessenger
const char		GG_MSG_NAME_RESOURCE_ID[] = "RsrcID";			// int32
const char		GG_MSG_NAME_RESULT[] = "Result";				// int32
const char		GG_MSG_NAME_VERSION[] = "Ver";					// String
// エラーコード
enum {	GG_ERR_GENERAL = B_ERRORS_END+1+GG_ERR_BASE,			// その他のエラー
		GG_ERR_ENTRY_NOT_FOUND,									// エントリーが見つからなかった
		GG_ERR_RESOURCE_ID_NOT_FOUND,							// 指定されたリソース ID のリソースが見つからなかった
		GG_ERR_BAD_TYPE,										// 型が BView ではない
		GG_ERR_END,												// （最後のエラーコード）
		GG_OK = B_OK											// 正常終了
		};

//------------------------------------------------------------------------------


//==============================================================================
#endif	// ___GGShared_H_
