#include <Message.h>
#include <Resources.h>
#include <Roster.h>
#include <Application.h>
#include <Bitmap.h>
#include <SupportDefs.h>
#include <string.h>
#include "About.h"
#include "Berry.h"


#define INFO_TEXT "Copyright ©2004-2007  momoziro\n"	\
	"ALL RIGHT RESERVED.\n"	\
	"\n"	\
	"Staff of " APP_NAME " development\n"	\
	"\n"	\
	"Directing and coding:\n"	\
	"	momoziro (fuhrer@haiku-talkers.net)\n"	\
	"\n"	\
	"Icon design:\n"	\
	"	Taxman\n"	\
	"\n"	\
	"Documentation:\n"	\
	"\n"	\
	"\n"	\
	"Beta tester:	\n"	\
	"	KiM\n"	\
	"\n"	\
	"Special Thanks:\n"	\
	"	All " APP_NAME " users!\n"


// TAboutView

TAboutView::TAboutView(BRect frame, const char *name)
	:	BView(frame, name, B_FOLLOW_ALL_SIDES, B_WILL_DRAW)
{
	fAppIcon = NULL;
	fMrBerryIcon = NULL;
	
	BFont font;
	
	fTitle = new BStringView(BRect(60, 20, 180, 50), "Title", APP_NAME);
	fTitle->GetFont(&font);
	font.SetSize(25);
	fTitle->SetFont(&font);
	AddChild(fTitle);
	
	fVersion = new BStringView(BRect(190, 30, 320, 45), "Version", GUIBERRY_VERSION);
	AddChild(fVersion);
	
	BRect rect(60, 65, 283, 140);
	fInfoText = new BTextView(rect, "InfoText",
		BRect(0, 0, rect.Width() - 1, rect.Height() - 1), B_FOLLOW_ALL, B_WILL_DRAW);
	fInfoText->SetViewColor(216, 216, 216);
	fInfoText->MakeEditable(false);
	fInfoText->SetText(INFO_TEXT);
	
	fInfoScrollView = new BScrollView("InfoScrollView", fInfoText,
		B_FOLLOW_LEFT | B_FOLLOW_TOP, 0, false, true, B_PLAIN_BORDER);
	AddChild(fInfoScrollView);
	
	app_info info;
	be_app->GetAppInfo(&info);
	BFile self(&info.ref, B_READ_ONLY);
	if (self.InitCheck() == B_OK) {
		BResources rsrc(&self);
		size_t size;
		char *data;
		data = (char *)rsrc.LoadResource('ICON', "BEOS:L:STD_ICON", &size);
		if (data != NULL) {
			fAppIcon = new BBitmap(BRect(0,0,31,31), B_CMAP8);
			memcpy(fAppIcon->Bits(), data, min_c((int)size, fAppIcon->BitsLength()));
		}
		data = (char *)rsrc.LoadResource('ICON', "Mr_Berry", &size);
		if (data != NULL) {
			fMrBerryIcon = new BBitmap(BRect(0,0,31,31), B_CMAP8);
			memcpy(fMrBerryIcon->Bits(), data, min_c((int)size, fMrBerryIcon->BitsLength()));
		}
	}
}

TAboutView::~TAboutView()
{
}

void TAboutView::Draw(BRect updateRect)
{
	PushState();
	SetDrawingMode(B_OP_COPY);
	SetHighColor(0xb5, 0xb5, 0xb5);
	FillRect(BRect(0, 0, 40, Frame().bottom));
	SetDrawingMode(B_OP_ALPHA);
	if (fAppIcon != NULL) DrawBitmap(fAppIcon, BPoint(24, 17));
	if (fMrBerryIcon != NULL) DrawBitmap(fMrBerryIcon, BPoint(Frame().right - 37, Frame().bottom - 45));
	PopState();
}


// TAboutWindow

TAboutWindow::TAboutWindow(BRect frame)
	:	BWindow(frame, "About " APP_NAME,
				B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE)
{
	fAboutView = new TAboutView(Bounds(), "AboutView");
	fAboutView->SetViewColor(216, 216, 216);
	this->AddChild(fAboutView);
}

TAboutWindow::~TAboutWindow()
{
}
