#include "BCLPictureButton.h"
#include "Berry.h"
#include "ToolTip.h"


BPicture *BmpToPicture(BBitmap *bmp, bool onEffect)
{
	BView *aView = new BView(BRect(0, 0, 27, 27), "aView", 0, 0);
	BBitmap *aBitmap = new BBitmap(aView->Bounds(), B_RGB32, true);
	aBitmap->AddChild(aView);
	aBitmap->Lock();
	aView->BeginPicture(new BPicture());
	if (bmp!=NULL) {
		aView->DrawBitmap(bmp);
		if (onEffect) {
			aView->SetDrawingMode(B_OP_BLEND);
			aView->SetHighColor(0x0, 0x0, 0xff);
			aView->FillRect(BRect(0, 0, 27, 27));
		}
	}
	BPicture *pic = aView->EndPicture();
	aBitmap->Unlock();
	delete aBitmap;
	return pic;
}

TBCLPictureButton::TBCLPictureButton(
			const char *name, const char *page,
			BPicture *off, BPicture *on, TBerryComponentLibrary *bcl)
	:	BPictureButton(BRect(0, 0, 27, 27), name, off, on, 
			new BMessage(GB_BCL_PRESSED), B_TWO_STATE_BUTTON, 0, B_WILL_DRAW)
{
	Page.SetTo(page);
	tool_tip.SetToolTip(this, name);
	fBCL = bcl;
}

TBCLPictureButton::~TBCLPictureButton()
{
}

void TBCLPictureButton::MakeOnOffPicture(BBitmap *bitmap, BPicture **on, BPicture **off)
{
	*off = BmpToPicture(bitmap, false);
	*on = BmpToPicture(bitmap, true);
}

void TBCLPictureButton::MouseDown(BPoint point)
{
	BMessage msg(BERRY_BCL_DROPPED);
	msg.AddPointer("bcl", fBCL);
	DragMessage(&msg, Bounds(), this);
	BPictureButton::MouseDown(point);
}
