#include <stdio.h>
#include "BCLTabView.h"
#include "BCLView.h"
#include "SimplePictureButton.h"

TBCLTabView::TBCLTabView(BRect frame, const char *name)
	:	BTabView(frame, name, B_WIDTH_FROM_LABEL,
		B_FOLLOW_ALL, B_WILL_DRAW | B_FRAME_EVENTS)
{
}

TBCLTabView::~TBCLTabView()
{
	for(int32 i=0; i < fNameList.CountItems(); i++) {
		BString *str = (BString *)fNameList.ItemAt(i);
		delete str;
	}
}

void TBCLTabView::AddTab(BView *target, BTab *tab)
{
	fNameList.AddItem(new BString(target->Name()));
	BTabView::AddTab(target, tab);
}

int32 TBCLTabView::FindTab(const char *label) const
{
	for(int32 i=0; i < fNameList.CountItems(); i++) {
		BString *str = (BString *)fNameList.ItemAt(i);
		if (str->Compare(label) == 0) {
			return i;
		}
	}
	return -1;
}

void TBCLTabView::Select(int32 tab)
{
	BTabView::Select(tab);
	BView *bgview = TabAt(tab)->View();
	bgview->ResizeBy(this->Bounds().Width() - bgview->Frame().Width(), 0);
	TBCLView *bcview = (TBCLView *)bgview->FindView("bcview");
	bcview->Align();
}
