#include "BCLView.h"
#include "Berry.h"
#include <stdio.h>

TBCLPictureButton *selected_bcl_button;		// 選択中のBCL

TBCLView::TBCLView(BRect frame, const char *name)
	:	BView(frame, name, B_FOLLOW_LEFT_RIGHT, B_FRAME_EVENTS | B_WILL_DRAW)
{
//	this->SetViewColor(166, 166, 166, 0);
	this->SetViewColor(216, 216, 216, 0);
}

TBCLView::~TBCLView()
{
}

void TBCLView::AddButton(BPictureButton *button)
{
	fButtonList.AddItem(button);
	button->MoveTo(30 * (fButtonList.CountItems()-1) + 2, 2);
	this->AddChild(button);
}

void TBCLView::AttachedToWindow()
{
}

void TBCLView::MessageReceived(BMessage *msg)
{
	switch(msg->what) {
		case GB_BCL_PRESSED: {
			void *p;
			if (msg->FindPointer("source", &p)==B_OK) {
				if (selected_bcl_button!=NULL) selected_bcl_button->SetValue(B_CONTROL_OFF);
				selected_bcl_button = reinterpret_cast<TBCLPictureButton *>(p);
				selected_bcl_button->SetValue(B_CONTROL_ON);
			}
			break;
		}
	}
}

void TBCLView::Deselect()
{
	for(int i=0; i < fButtonList.CountItems(); i++) {
		((BPictureButton *)fButtonList.ItemAt(i))->SetValue(B_CONTROL_OFF);
	}
	selected_bcl_button = NULL;
}

float TBCLView::Width() const
{
	return fButtonList.CountItems() * 30;
}

void TBCLView::Align()
{
	for(int32 i=0; i < fButtonList.CountItems(); i++) {
		((BPictureButton *)fButtonList.ItemAt(i))->MoveTo(30 * i + 2, 2);
	}
}
