#ifndef _BERRY_H
#define _BERRY_H

#include <typeinfo>
#include <TypeConstants.h>
#include <image.h>
#include <Archivable.h>
#include <String.h>
#include <List.h>

#include "BCL.h"
#include "PropEditor.h"

#define APP_NAME "GuiBerry"
#define RESOURCE_NAME "BerryResources"
#define BERRY_CLIP_NAME "BCL clip"
#define GUIBERRY_VERSION "Version 1.10"

enum {
	GB_BCL_PRESSED = 'bbpr',
	GB_HAND_CURSOR_CLICKED = 'bhcc',
	GB_BCL_LEFTBTN_PRESSED = 'bblp',
	GB_BCL_RIGHTBTN_PRESSED = 'bbrp',
	GB_NEW_RESOURCE = 'newr',
	GB_LOAD = 'load',
	GB_SAVEAS = 'svas',
	GB_SAVE = 'save',
	GB_TEST_RUN = 'btrn',
	GB_OPEN_VIEWIT = 'ovit',
	GB_SHOW_HELP = 'shlp',
};

class TPropEditor;


typedef struct TAddonItem {
	void *(*instantiate_objects)(instantiation_info_t *info, register_component *RegisterComponent);
	TPropEditor *(*register_prop_editors)(const type_info *typeInfo, propeditor_info_t *peInfo);
	image_id id;
} TAddonItem;


extern BList AddonList;
extern BList BCLList;


#endif
