#include <String.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <View.h>
#include <Looper.h>
#include <Roster.h>
#include <Application.h>
#include <Path.h>
#include <Entry.h>

#include "Berry.h"
#include "BerryUtils.h"


int GetNumber(const char *&name)
{
	int val = atoi(name);
	while (isdigit(*name)) { 
		++name;
	} 
	return val;
}

void LockObjectLooper(BArchivable *object)
{
	BView *view = dynamic_cast<BView *>(object);
	if (view!=NULL) {
		if (view->Looper() != NULL) {
			view->Looper()->Lock();
		}
	}
}

void UnlockObjectLooper(BArchivable *object)
{
	BView *view = dynamic_cast<BView *>(object);
	if (view!=NULL) {
		if (view->Looper() != NULL) {
			view->Looper()->Unlock();
		}
	}
}

status_t FindSupportBCL(BArchivable *object, TBerryComponentLibrary **bcl)
{
	TBerryComponentLibrary *_bcl = NULL;
	const char *typeidName = typeid(*object).name();
	for(int32 i=0; i<BCLList.CountItems(); i++) {
		*bcl = (TBerryComponentLibrary *)BCLList.ItemAt(i);
		if (strcmp(typeidName, (*bcl)->SupportedClass())==0) {
			return B_OK;
		}
		if (strcmp("5BView", (*bcl)->SupportedClass())==0) {
			_bcl = *bcl;
		}
	}
	fprintf(stderr, APP_NAME ": Unsupported! (%s)\n", typeidName);
	*bcl = _bcl;
	return B_ERROR;
}

status_t GetAddonDir(const char *leaf, BString *get_path)
{
	app_info info;
	status_t status;
	
	status = be_app->GetAppInfo(&info);
	if (status != B_OK) return status;
	
	BEntry entry(&info.ref);
	BEntry parent;
	status = entry.GetParent(&parent);
	if (status != B_OK) return status;
	
	BPath path(&parent);
	status = path.Append(leaf);
	if (status != B_OK) return status;
	if (get_path == NULL) return B_ERROR;
	get_path->SetTo(path.Path());
	return B_OK;
}
