#include <stdio.h>
#include <stdlib.h>
#include "BpntEditorWindow.h"


enum {
	EW_APPLY = 'ewap',
	EW_CANCEL = 'ewca',
};

// TBpntEditorView

TBpntEditorView::TBpntEditorView(BRect frame, const char *name)
	:	BView(frame, name, B_FOLLOW_ALL_SIDES, B_WILL_DRAW | B_FRAME_EVENTS)
{
}

TBpntEditorView::~TBpntEditorView()
{
}


// TBpntEditorWindow

TBpntEditorWindow::TBpntEditorWindow(BRect frame, const char *title,
			type_code type, TResAddon *addon)
	:	TResEditorWindow(frame, title,
			B_TITLED_WINDOW, B_NOT_ZOOMABLE | B_NOT_RESIZABLE)
{
	fType = type;
	fAddon = addon;
	
	fBpntEditorView = new TBpntEditorView(Bounds(), "EditorView");
	fBpntEditorView->SetViewColor(216, 216, 216);
	AddChild(fBpntEditorView);
	
	fPointX = new BTextControl(BRect(10, 10, 120, 20), "PointX", "X:", "", NULL);
	fPointX->SetDivider(20);
	fBpntEditorView->AddChild(fPointX);
	
	fPointY = new BTextControl(BRect(10, 30, 120, 40), "PointY", "Y:", "", NULL);
	fPointY->SetDivider(20);
	fBpntEditorView->AddChild(fPointY);
	
	fApplyButton = new BButton(BRect(50, 60, 110, 75),
			"Apply", "Apply", new BMessage(EW_APPLY));
	fApplyButton->MakeDefault(true);
	fBpntEditorView->AddChild(fApplyButton);
	fCancelButton = new BButton(BRect(120, 60, 180, 75),
			"Cancel", "Cancel", new BMessage(EW_CANCEL));
	fBpntEditorView->AddChild(fCancelButton);
	
	fPointX->TextView()->MakeFocus();
	
	fData.SetTo("");
}

TBpntEditorWindow::~TBpntEditorWindow()
{
}

void TBpntEditorWindow::MessageReceived(BMessage *msg)
{
	switch(msg->what) {
		case EW_APPLY:
			SendData();
			break;
		case EW_CANCEL:
			Quit();
			break;
		default: BWindow::MessageReceived(msg);
	}
}

status_t TBpntEditorWindow::InstantiateFromData(const void *data,
		ssize_t numBytes)
{
	switch(fType){
		case 'BPNT': {
			BString str;
			BPoint point = *(BPoint *)data;
			str << point.x;
			fPointX->SetText(str.String());
			str = "";
			str << point.y;
			fPointY->SetText(str.String());
			break;
		}
	}
	fPointX->TextView()->SelectAll();
	return true;
}

void TBpntEditorWindow::GetData(BMallocIO *data)
{
	data->SetSize(0);
	switch(fType) {
		case 'BPNT': {
			BPoint point;
			point.x = atof(fPointX->Text());
			point.y = atof(fPointY->Text());
			data->Write(&point, sizeof(point));
			break;
		}
	}
}
