#ifndef _CONTAINERWINDOW_H
#define _CONTAINERWINDOW_H


#include <Window.h>
#include "ResAddon.h"
#include "ContainerView.h"

class TTestWindow : public BWindow
{
public:
	TTestWindow(const char *title);
	~TTestWindow();
	bool QuitRequested();
};

class TContainerWindow : public TResEditorWindow
{
public:
	TContainerWindow(BRect frame, const char *title);
	~TContainerWindow();
	void Quit();
	void MessageReceived(BMessage *msg);	
	TContainerView *ContainerView() const { return fContainerView; };
	void GetArchive(BMessage *archive);
	void WindowActivated(bool active);
	
	status_t InstantiateFromData(const void *data, ssize_t numBytes);
	void TestRun();
	void OpenViewIt();
	
	void GetData(BMallocIO *data);
	void SendData() { TResEditorWindow::SendData(); };
private:
	TContainerView *fContainerView;
	TTestWindow *fTestWindow;
};

extern TContainerWindow *last_activated_container;


#endif
