#include <stdio.h>
#include <stdlib.h>
#include <ScrollView.h>
#include "CstrEditorWindow.h"

enum {
	EW_APPLY = 'ewap',
	EW_CANCEL = 'ewca',
};

// TCstrEditorView

TCstrEditorView::TCstrEditorView(BRect frame, const char *name)
	:	BView(frame, name, B_FOLLOW_ALL_SIDES, B_WILL_DRAW | B_FRAME_EVENTS)
{
}

TCstrEditorView::~TCstrEditorView()
{
}


// TCstrEditorWindow

TCstrEditorWindow::TCstrEditorWindow(BRect frame, const char *title,
			type_code type, TResAddon *addon)
	:	TResEditorWindow(frame, title,
			B_TITLED_WINDOW, 0)
{
	fType = type;
	fAddon = addon;
	
	fCstrEditorView = new TCstrEditorView(Bounds(), "CstrEditorView");
	fCstrEditorView->SetViewColor(216, 216, 216);
	AddChild(fCstrEditorView);
	
	BRect rect(Bounds());
	rect.right -= B_V_SCROLL_BAR_WIDTH;
	rect.bottom -= 30;
	fCstrEditorTextView = new BTextView(rect,
			"CstrEditorTextView", rect, B_FOLLOW_ALL_SIDES, B_WILL_DRAW | B_FRAME_EVENTS);
	fCstrEditorTextView->SetWordWrap(true);
	BScrollView *scrollView = new BScrollView("scrollView", fCstrEditorTextView,
		B_FOLLOW_ALL_SIDES, 0, false, true);
	fCstrEditorView->AddChild(scrollView);
	
	float y = rect.bottom + 4;
	fApplyButton = new BButton(BRect(200, y, 260, y + 15),
			"Apply", "Apply", new BMessage(EW_APPLY), B_FOLLOW_RIGHT | B_FOLLOW_BOTTOM);
	fCstrEditorView->AddChild(fApplyButton);
	fCancelButton = new BButton(BRect(265, y, 325, y + 15),
			"Cancel", "Cancel", new BMessage(EW_CANCEL), B_FOLLOW_RIGHT | B_FOLLOW_BOTTOM);
	fCstrEditorView->AddChild(fCancelButton);
	
	fCstrEditorTextView->MakeFocus();
	
	fData.SetTo("");
}

TCstrEditorWindow::~TCstrEditorWindow()
{
}

void TCstrEditorWindow::MessageReceived(BMessage *msg)
{
	switch(msg->what) {
		case EW_APPLY:
			fData.SetTo(fCstrEditorTextView->Text());
			SendData();
			break;
		case EW_CANCEL:
			Quit();
			break;
		default: BWindow::MessageReceived(msg);
	}
}

status_t TCstrEditorWindow::InstantiateFromData(const void *data,
		ssize_t numBytes)
{
	BString str;
	switch(fType){
		case 'CSTR': {
			if (numBytes > 0) str.SetTo((const char *)data, numBytes);
			break;
		}
		default: fCstrEditorTextView->SetText("");
	}
	fCstrEditorTextView->SetText(str.String());
	fData.SetTo(str.String());
}

void TCstrEditorWindow::GetData(BMallocIO *data)
{
	data->SetSize(0);
	const char *text = fData.String();
	size_t length = fCstrEditorTextView->TextLength();
	switch(fType) {
		case 'CSTR': {
			data->Write(text, length);
			break;
		}
		default: ;
	}
	BString str;
	fAddon->String(data, &str);
}
