#ifndef _GGSERVER_H
#define _GGSERVER_H


#include <Looper.h>
#include <Message.h>
#include <Messenger.h>
#include <List.h>
#include <Entry.h>
#include "GGShared.h"
#include "ResManager.h"

class TGGItem
{
public:
	entry_ref gi_ref;
	int32 gi_id;
};

class TGGServer : public BLooper
{
public:
	TGGServer();
	~TGGServer();
	void MessageReceived(BMessage *msg);
	int32 FindGGItem(entry_ref *ref, int32 id) const;
	
private:
	TResManager *fFindManager(BEntry *entry);
	void fGGStartCommunication(BMessage *msg);
	void fGGEndCommunication(BMessage *msg);
	void fGGOpenViewRequested(BMessage *msg);
	void fGGSendViewRequested(BMessage *msg);
	void fGGComponentChanged(BMessage *msg);
	void ffGGSaveAllRequested(BMessage *msg);
	BMessenger fGGMessenger;
	BList fGGList;
};


extern TGGServer *gg_server;

#endif
