#include <Application.h>
#include <FilePanel.h>
#include "MainWindow.h"
#include "ObjectInspectorWindow.h"
#include "ResManager.h"
#include "About.h"
#include "List.h"
#include "GGServer.h"

class TGuiBerry : public BApplication
{
public:
	TGuiBerry();
	~TGuiBerry();
	void RefsReceived(BMessage *msg);
	void MessageReceived(BMessage *msg);
	void AboutRequested();
	void ReadyToRun();
	void NewResource();
private:
	TObjectInspectorWindow *fObjectInspectorWindow;
	TMainWindow *fMainWindow;
	TResManager *fResManager;
	BFilePanel *fLoadPanel;
	
	void fLoadAddons(const char *addonsDir, BList *addonList);
	void fLoadAddon(const entry_ref *ref, BList *addonList);
	void fUnloadAddons();
	TAboutWindow *fAboutWindow;
	int32 fResourceCount;
};
