#ifndef _LOCALE_H
#define _LOCALE_H

#include <BeBuild.h>
#include <string.h>

#define GET_STRING(s, d)	get_local_string_d(s, d)


#if B_BEOS_VERSION < 0x0520

#include <DataIO.h>

class TZetaLocale : public BMallocIO
{
public:
	TZetaLocale(const char *name, const char *lang);
	void LoadLanguageFile(const char *name, const char *lang);
	void SetTo(const char *path, const char *lang);
	const char *GetString(const char* msg);
};

extern TZetaLocale *be_locale;

#define GETSTRING(s)	get_local_string(s)

#ifdef __cplusplus
extern "C" {
#endif

const char *get_local_string(const char* key);

#ifdef __cplusplus
}
#endif

#else

#include <Locale.h>

#endif	/* B_BEOS_VERSION */


#ifdef __cplusplus
extern "C" {
#endif

const char *get_local_string_d(const char* key, const char* defaultString);

#ifdef __cplusplus
}
#endif

#endif
