#ifndef _MAINVIEW_H
#define _MAINVIEW_H

#include <View.h>
#include <Menu.h>
#include <MenuBar.h>
#include <MenuItem.h>
#include <interface/TabView.h>

#include "SimplePictureButton.h"
#include "Berry.h"
#include "BCLTabView.h"


class TMainView : public BView
{
public:
	TMainView(BRect frame,
			const char *name,
			uint32 resizingMode,
			uint32 flags);
	~TMainView();
	
	void AttachedToWindow();
	void MessageReceived(BMessage *msg);
	void DeselectAll();
private:
	void LanguageChanged();
	
	TBCLTabView *fBCLTabView;
	TSimplePictureButton *fHandCursorButton;
	TSimplePictureButton *fNewButton;
	TSimplePictureButton *fOpenButton;
	TSimplePictureButton *fSaveButton;
	TSimplePictureButton *fTestRunButton;
	TSimplePictureButton *fOpenViewItButton;
	
	BMenuBar *fMenuBar;
	BMenu *fFileMenu;
	BMenu *fDebuggerMenu;
	BMenuItem *fNewResourceMenuItem;
	BMenuItem *fLoadMenuItem;
	BMenuItem *fSaveMenuItem;
	BMenuItem *fSaveAsMenuItem;
	BMenuItem *fAboutMenuItem;
	BMenuItem *fQuitMenuItem;
	BMenuItem *fTestRunMenuItem;
	BMenuItem *fOpenViewItItem;
};


extern TMainView *main_view;


#endif
