#include <Alert.h>
#include <stdio.h>
#include <Screen.h>
#include <SupportDefs.h>

#include "MainWindow.h"
#include "GuiBerry.h"
#include "Locale.h"


// TMainWindow

TMainWindow::TMainWindow(BRect frame, const char *title)
	:	BWindow(frame, title, B_TITLED_WINDOW, B_NOT_ZOOMABLE | B_NOT_V_RESIZABLE)
{
	BScreen screen;
	
	// Main View
	main_view = new TMainView(Bounds(), "MainView",
		B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP_BOTTOM,
		B_WILL_DRAW | B_FRAME_EVENTS);
	this->AddChild(main_view);
	main_view->SetViewColor(216, 216, 216, 0);
}

TMainWindow::~TMainWindow()
{
}

bool TMainWindow::QuitRequested()
{
	bool quit;
	for(int32 i=res_manager_list.CountItems() - 1; i >= 0; i--) {
		TResManager *cw = (TResManager *)res_manager_list.ItemAt(i);
		cw->Lock();
		quit = cw->AppQuitRequested(true);
		cw->Unlock();
		if (quit) {
			cw->Lock();
			cw->Quit();
		} else {
			return false;
		}
	}
	
	if (res_manager_list.CountItems() == 0) {
		be_app_messenger.SendMessage(B_QUIT_REQUESTED);
		return true;
	} else {
		return false;
	}
}

void TMainWindow::LanguageChanged()
{
#ifdef B_LANGUAGE_CHANGED
	BMessenger(main_view).SendMessage(B_LANGUAGE_CHANGED);
#endif
}

void TMainWindow::MessageReceived(BMessage *msg)
{
	switch(msg->what) {
		case B_SIMPLE_DATA:
		case B_REFS_RECEIVED:
			be_app_messenger.SendMessage(msg);
			break;
		case GB_SAVE: 
		case GB_SAVEAS:
			if (last_activated_manager != NULL) {
				BMessenger(last_activated_manager).SendMessage(msg);
			}
			break;
		case GB_TEST_RUN:
		case GB_OPEN_VIEWIT:
			if (last_activated_container != NULL) BMessenger(last_activated_container).SendMessage(msg);
			break;
#ifdef B_LANGUAGE_CHANGED
		case B_LANGUAGE_CHANGED:
			LanguageChanged();
			break;
#endif			
		default: BWindow::MessageReceived(msg);
	}
}
