#ifndef _OBJECTINSPECTORVIEW_H
#define _OBJECTINSPECTORVIEW_H

#include "ColumnListView.h"
#include "CLVEasyItem.h"

#include "ObjectInspectorItem.h"
#include "Berry.h"

class TObjStack
{
public:
	TObjStack();
	~TObjStack();
	void Push(const BArchivable *object);
	status_t Pop(BArchivable **object);
private:
	BList fObjectList;
};

class TObjectInspectorView : public ColumnListView
{
public:
	TObjectInspectorView(BRect frame,
						const char *name,
						uint32 resizingMode,
						uint32 flags);
	~TObjectInspectorView();
	void MessageReceived(BMessage *msg);
	CLVContainerView *View() { return iContainerView; };
	void SelectionChanged();
	void WindowActivated(bool active);
	void UpdateValue(TObjectInspectorItem *item);
	TObjectInspectorItem *LastSelectedItem();
	BList *ObjectList();
	BMessenger *TargetMessenger();
	void UpdateInspector();
	void KeyDown(const char *bytes, int32 numBytes);
	void MakeEmpty();
	void Help(const char *bclClassName = NULL, const char *propertyName = NULL);
	void MakeChangedMessage(BMessage *msg, TObjectInspectorItem *item);
	
private:
	CLVContainerView *iContainerView;
	BList fObjectList;		// 現在選択されているオブジェクトのリスト
//	BWindow *fFromWindow;
	TObjectInspectorItem *fLastSelectedItem;
	void fViewSelected();
	BMessenger fTargetMessenger;
	void fLoadAddon(const entry_ref *ref, BList *addonList);
	void fLoadAddons(const char *addonsDir, BList *addonList);
	void fUnloadAddons();
	TSinglePropEditor *FindPropEditor(TSinglePropEditor *editor) const;
	void fOpenPropertyEditor(TObjectInspectorItem *item, const type_info *typeInfo);
};

extern TObjectInspectorView *ObjectInspectorView;


#endif
