#include <String.h>
#include <List.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <typeinfo>
#include <Application.h>
#include "ObjectInspectorWindow.h"
#include "Berry.h"
#include "Locale.h"


extern BTextControl *ObjectTypeName;


TObjectInspectorWindow::TObjectInspectorWindow(BRect frame, const char *title)
	:	BWindow(frame, title, B_DOCUMENT_WINDOW, B_NOT_ZOOMABLE | B_NOT_CLOSABLE)
{
	BRect rect;
	
	// Object Type
	rect = Bounds();
	rect.left -= 3;
	rect.bottom = rect.top + 15;
	ObjectTypeName = new BTextControl(rect, "ObjectTypeName", "", "", NULL, B_FOLLOW_LEFT_RIGHT);
	ObjectTypeName->SetDivider(0);
	AddChild(ObjectTypeName);
	ObjectTypeName->TextView()->MakeEditable(false);
	
	// Object Inspector
	rect = Bounds();
	rect.top = ObjectTypeName->Frame().bottom + 2;
	rect.right -= B_V_SCROLL_BAR_WIDTH;
	rect.bottom -= B_H_SCROLL_BAR_HEIGHT;
	ObjectInspectorView = new TObjectInspectorView(rect, "ObjectInspectorView",
		B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP_BOTTOM,
		B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE);
	AddChild(ObjectInspectorView->View());
	ObjectInspectorView->MakeFocus();
	
	AddShortcut('O', 0, new BMessage(GB_LOAD));
	AddShortcut('S', 0, new BMessage(GB_SAVE));
	AddShortcut('R', 0, new BMessage(GB_TEST_RUN));
	AddShortcut('B', 0, new BMessage(GB_OPEN_VIEWIT));
	
	LanguageChanged();
}

TObjectInspectorWindow::~TObjectInspectorWindow()
{
}

void TObjectInspectorWindow::LanguageChanged()
{
#ifdef B_LANGUAGE_CHANGED
	BMessenger(ObjectInspectorView).SendMessage(B_LANGUAGE_CHANGED);
#endif
	SetTitle(GET_STRING("O_ObjectInspector", "Object Inspector"));
}

void TObjectInspectorWindow::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case GB_LOAD:
		case GB_SAVE:
		case GB_TEST_RUN:
		case GB_OPEN_VIEWIT:
			BMessenger(be_app).SendMessage(msg);
			break;
#ifdef B_LANGUAGE_CHANGED
		case B_LANGUAGE_CHANGED: {
			LanguageChanged();
			break;
		}
#endif
		default: BWindow::MessageReceived(msg);
	}
}
