#ifndef _RESADDON_H
#define _RESADDON_H

#include <SupportDefs.h>
#include <List.h>
#include <String.h>
#include <DataIO.h>
#include <Window.h>
#include <Entry.h>


// TResEditorWindow

class TResEditorWindow : public BWindow
{
public:
	TResEditorWindow(BRect frame, const char *title,
			window_type type, uint32 flags, uint32 workspaces = B_CURRENT_WORKSPACE);
	~TResEditorWindow();
	virtual status_t InstantiateFromData(const void *data, ssize_t numBytes) = 0;
	void SetParameter(BMessenger *msgr, const char *name, type_code type, int32 id, const entry_ref *ref);
	void GetParameter(BMessenger *msgr, BString *name, type_code *type, int32 *id, entry_ref *ref);
	void SetDirty();
protected:
	virtual void GetData(BMallocIO *data) = 0;
	void SendData();
private:
	BMessenger fMessenger;
	BString fName;
	type_code fType;
	int32 fID;
	entry_ref fRef;
};


// TResAddon

class TResAddon
{
public:
	TResAddon();
	virtual ~TResAddon();
	virtual void GetType(BString *desc, type_code *type) = 0;
	virtual void New(BDataIO *data) = 0;
	virtual void String(BMallocIO *data, BString *string);
	virtual TResEditorWindow *OpenEditor(const char *title) = 0;
};


// TResAddon_unknown

class TResAddon_unknown : public TResAddon
{
public:
	TResAddon_unknown();
	~TResAddon_unknown();
	void GetType(BString *desc, type_code *type);
	void New(BDataIO *data);
	void String(BMallocIO *data, BString *string);
	TResEditorWindow *OpenEditor(const char *title);
};


// TResAddons

class TResAddons
{
public:
	TResAddons();
	~TResAddons();
	TResAddon_unknown *UnknownResAddon() const;
	int32 CountAddons() const;
	TResAddon *AddonAt(int32 index) const;
	TResAddon *FindResAddon(type_code type) const;
private:
	TResAddon_unknown *fUnknownResAddon;
	BList fAddonList;
};


extern TResAddons res_addons;


#endif
