#ifndef _TOOLTIP_H
#define _TOOLTIP_H

#include <Application.h>
#include <Messenger.h>
#include <MessageFilter.h>
#include <String.h>
#include <List.h>
#include <Window.h>
#include <TextView.h>
#include <MessageRunner.h>
#include <View.h>

class TToolTipWindow : public BWindow
{
public:
	TToolTipWindow();
	~TToolTipWindow();
	void MessageReceived(BMessage *msg);
private:
	void SetToolTip(BView *target, const char *tip);
	void CloseToolTip();
	void ShowToolTip();
	BView *BGView;
	BView *Target;
	BTextView *TipText;
	int32 fPulseCount;
	BMessageRunner *fRunner;
	bool fRunnerEnabled;
};

class TToolTipFilter : public BMessageFilter
{
public:
	TToolTipFilter(BView *target);
	~TToolTipFilter();
	filter_result Filter(BMessage *msg, BHandler **target);
	void SetToolTip(const char *tip);
private:
	BView *Target;
	BString ToolTip;
	void ShowToolTip();
};

class TToolTip
{
public:
	TToolTip();
	~TToolTip();
	status_t SetToolTip(BView *target, const char *tip);
	BPoint CursorPos;
	BView *LastToolTipTargetView;
	TToolTipWindow *ToolTipWindow;
};

extern TToolTip tool_tip;


#endif
